<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container-fluid">
        <h1 class="text-center">Danh sách người dùng đăng ký</h1>
        <button class="btn btn-success mb-2" id="btn-add-user"><i class="fa fa-plus"></i>New user</button>
        <table class="table table-bordered table-hover table-striped" id="user-table">
            <thead> 
                <tr>
                    <th>Id</th>
                    <th>FirstName</th>
                    <th>LastName</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>

    <!-- Vùng Modal -->

  <!-- Create user modal -->
  <div>
    <div id="create-user-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Create new User</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-firstname">First name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-firstname" placeholder="First name"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-lastname">Last name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-lastname" name="lastname" placeholder="Last name"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-subject">Subject</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-subject" name="subject" placeholder="Subject"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                    <label>Country</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="select-country" name="Customertype">
                        <option value="VN">Viet Nam</option>
                        <option value="USA">USA</option>
                        <option value="AUS">Australia</option>
                        <option value="CAN">Canada</option>
                    </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4">
                    <label>Customer Type</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="select-customerType" name="Customertype">
                        <option value="Standard">Standard</option>
                        <option value="Gold">Gold</option>
                        <option value="Premium">Premium</option>
                    </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4">
                    <label>Register Status</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="select-registerStatus" name="registerStatus">
                        <option value="New">New</option>
                        <option value="Accepted">Accepted</option>
                        <option value="Denied">Denied</option>
                    </select>
                </div>
            </div>

            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-create-user">Create User</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Update user modal -->
  <div>
    <div id="update-user-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Update User</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-fname">First name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-fname"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-lname">Last name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-lname" name="lastname" 
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-subject">Subject</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-subject" name="subject"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                    <label>Country</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="selected-country" name="Customertype">
                        <option value="VN">Viet Nam</option>
                        <option value="USA">USA</option>
                        <option value="AUS">Australia</option>
                        <option value="CAN">Canada</option>
                    </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4">
                    <label>Customer Type</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="selected-customerType" name="Customertype">
                        <option value="Standard">Standard</option>
                        <option value="Gold">Gold</option>
                        <option value="Premium">Premium</option>
                    </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-4">
                    <label>Register Status</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="selected-registerStatus" name="registerStatus">
                        <option value="New">New</option>
                        <option value="Accepted">Accepted</option>
                        <option value="Denied">Denied</option>
                    </select>
                </div>
            </div>

            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-update-user">Update User</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa user này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Biến toàn cục để lưu trữ id voucher đang đc update or delete. Mặc định = 0;
    var gUserId = 0;
  
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
  
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject","customerType","registerStatus","action"];
  
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL =6;
    const gACTION_COL = 7;

    // Khai báo DataTable & mapping collumns
    var gUserTable = $("#user-table").DataTable({
      columns: [
        { data: gUSER_COLS[gUSER_ID_COL] },
        { data: gUSER_COLS[gFIRST_NAME_COL] },
        { data: gUSER_COLS[gLAST_NAME_COL] },
        { data: gUSER_COLS[gCOUNTRY_COL] },
        { data: gUSER_COLS[gSUBJECT_COL] },
        { data: gUSER_COLS[gCUSTOMER_TYPE_COL] },
        { data: gUSER_COLS[gREGISTER_STATUS_COL] },
        { data: gUSER_COLS[gACTION_COL] },
      ],
      columnDefs: [
        { // định nghĩa lại cột action
          targets: gACTION_COL,
          defaultContent: `
          <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
          <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
        `
        }
      ]
    });
  
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      // thực hiện tải trang
      onPageLoading();
      // 2 - C: gán sự kiện Create - Thêm mới voucher
      $("#btn-add-user").on("click", function () {
        onBtnAddNewUserClick();
      });
      // 3 - U: gán sự kiện Update - Sửa 1 user
      $("#user-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
      });
      // 4 - D: gán sự kiện delete - Xóa 1 user
      $("#user-table").on("click", ".delete-user", function () {
        onBtnDeleteUserClick(this);
      });

      //phần modal
      // gán sự kiện cho nút Create User (trên modal)
      $("#btn-create-user").on("click", function () {
        onBtnCreateUserClick();
      });
  
      // gán sự kiện cho nút Update User (trên modal)
      $("#btn-update-user").on("click", function () {
        onBtnUpdateUserClick();
      });
      // Gán sự kiện cho nút Confirm Delete user (trên modal)
      $("#btn-confirm-delete-user").on("click", function () {
        onBtnConfirmDeleteUserClick();
      });
    });
  
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
      // 1 - R: Read / Load voucher to DataTable
      getAllUsers();
    }
  
    // Hàm xử lý sự kiện khi nút Thêm mới đc click
    function onBtnAddNewUserClick() {
      // hiển thị modal trắng lên
      $("#create-user-modal").modal("show");
    }
  
    // Hàm xử lý sự kiện khi icon edit user trên bảng đc click
    function onBtnEditUserClick(paramBtnEdit) {
      // lưu thông tin UserID đang được edit vào biến toàn cục
      gUserId = getUserIdFromButton(paramBtnEdit);
      console.log("User ID vừa được ấn insert: " + gUserId);
      // load dữ liệu vào các trường dữ liệu trong modal
      getUserById(gUserId);
    }
    // Hàm xử lý sự kiện khi icon delete voucher trên bảng được click
    function onBtnDeleteUserClick(paramBtnDelete){
      "use strict";
      // lưu thông tin userId đang được edit vào biến toàn cục
      gUserId = getUserIdFromButton(paramBtnDelete);
      console.log("User ID vừa được ấn delete: " + gUserId);
      // Show modal delete
      // hiển thị modal delete lên
      $("#delete-confirm-modal").modal("show");
    }
    // hàm xử lý sự kiện create voucher modal click
    function onBtnCreateUserClick() {
      // khai báo đối tượng chứa voucher data
      var vUserObj = {
        id: "",
        firstname: "",
        lastname:"",
        country:"",
        subject:"",
        customerType:"",
        registerStatus:""
      };
      // B1: Thu thập dữ liệu
      getCreateUserData(vUserObj);
      console.log(vUserObj);
      // B2: Validate insert
      var vIsUserValidate = validateUserData(vUserObj);
      if (vIsUserValidate) {
        // B3: insert user
        $.ajax({
          url: gBASE_URL,
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vUserObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertUserSuccess()
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
  
    // hàm xử lý sự kiện update user modal click
    function onBtnUpdateUserClick() {
      // khai báo đối tượng chứa user data
      var vUserObj = {
        "id": "",
        "firstname": "",
        "lastname":"",
        "country":"",
        "subject":"",
        "customerType":"",
        "registerStatus":""
      };
      // B1: Thu thập dữ liệu
      getUpdateUserData(vUserObj);
      console.log(vUserObj);
      // B2: Validate update
      var vIsUserValidate = validateUserData(vUserObj);
      if (vIsUserValidate) {
        // B3: update user
        $.ajax({
          url: gBASE_URL + gUserId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vUserObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleUpdateUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
    // hàm xử lý sự kiện delete user modal click
    function onBtnConfirmDeleteUserClick(){
      "use strict";
      $.ajax({
          url: gBASE_URL + gUserId,
          type: "DELETE",       
          success: function (paramRes) {
            // B4: xử lý front-end
            handleDeleteUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách user đăng ký
    function getAllUsers() {
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        success: function (paramUser) {
          console.log(paramUser)
          loadDataToUserTable(paramUser);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load user array to DataTable
     * in: user array
     * out: user table has data
     */
    function loadDataToUserTable(paramUserArr) {

      gUserTable.clear();
      gUserTable.rows.add(paramUserArr);
      gUserTable.draw();
    }
  
    // hàm get user by id
    function getUserById(paramUserId) {
      $.ajax({
        url: gBASE_URL + paramUserId,
        type: "GET",
        success: function (paramUser) {
          showUserDataToModal(paramUser);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
      // hiển thị modal lên
      $("#update-user-modal").modal("show");
    }
  
    // hàm show user obj lên modal
    function showUserDataToModal(paramUser) {
      $("#inp-fname").val(paramUser.firstname);
      $("#inp-lname").val(paramUser.lastname);
      $("#input-subject").val(paramUser.subject);
      $("#selected-country").val(paramUser.country);
      $("#selected-customerType").val(paramUser.customerType);
      $("#selected-registerStatus").val(paramUser.registerStatus);
    }
  
    // hàm thu thập dữ liệu để create user
    function getCreateUserData(paramUserObj) {
      paramUserObj.firstname = $("#inp-firstname").val().trim();
      paramUserObj.lastname = $("#inp-lastname").val().trim();
      paramUserObj.subject = $("#inp-subject").val().trim();
      paramUserObj.country = $("#select-country").val();
      paramUserObj.customerType = $("#select-customerType").val();
      paramUserObj.registerStatus = $("#select-registerStatus").val();
    }
  
    // hàm thu thập dữ liệu để update user
    function getUpdateUserData(paramUserObj) {
      paramUserObj.firstname = $("#inp-fname").val().trim();
      paramUserObj.lastname = $("#inp-lname").val().trim();
      paramUserObj.subject = $("#input-subject").val().trim();
      paramUserObj.country = $("#selected-country").val();
      paramUserObj.customerType = $("#selected-customerType").val();
      paramUserObj.registerStatus = $("#selected-registerStatus").val();
    }
  
    // hàm validate data
    function validateUserData(paramUserObj) {
      if (paramUserObj.firstname == "") {
        alert("First name cần nhập");
        return false;
      }
      if (paramUserObj.lastname == "") {
        alert("Last name cần nhập");
        return false;
      }
      if (paramUserObj.subject == "") {
        alert("subject cần nhập");
        return false;
      }
      if(paramUserObj.country == "") {
        alert("Country chưa chọn");
        return false;
      }
      if(paramUserObj.customerType == "") {
        alert("Customer Type chưa chọn");
        return false;
      }
      if(paramUserObj.registerStatus == "") {
        alert("Register Status chưa chọn");
        return false;
      }
      return true;
    }
  
    // hàm xử lý hiển thị front-end khi thêm user thành công
    function handleInsertUserSuccess() {
      alert("Thêm user thành công!");
      getAllUsers();
      resertCreateUserForm();
      $("#create-user-modal").modal("hide");
    }
  
    // hàm xử lý hiển thị front-end khi sửa user thành công
    function handleUpdateUserSuccess() {
      alert("Sửa user thành công!");
      getAllUsers();
      resertUpdateUserForm();
      $("#update-user-modal").modal("hide");
    }
    // Hàm xử lý hiển thị front-end khi xóa user thành công
    function handleDeleteUserSuccess(){
      alert("Xóa user thành công!");
      getAllUsers();    
      $("#delete-confirm-modal").modal("hide");
    }
    // hàm xóa trắng form create user
    function resertCreateUserForm() {
      $("#inp-firstname").val("");
      $("#inp-lastname").val("");
      $("#inp-subject").val("");
      $("#select-country").val("");
      $("#select-customerType").val("");
      $("#select-registerStatus").val("");
    }
  
    // hàm xóa trắng form update user
    function resertUpdateUserForm() {
      $("#inp-fname").val("");
      $("#inp-lname").val("");
      $("#input-subject").val("");
      $("#selected-country").val("");
      $("#selected-customerType").val("");
      $("#selected-registerStatus").val("");
    }
  
    // hàm dựa vào button detail (edit or delete) xác định đc id user
    function getUserIdFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vUserRowData = gUserTable.row(vTableRow).data();
      return vUserRowData.id;
    }
  
  </script>
</html>